<?php
/**
* @version      2.0.4 05.09.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class JshoppingControllerProducts extends JController{
    
    function __construct( $config = array() ){
        parent::__construct( $config );

        $this->registerTask( 'add',   'edit' );
        $this->registerTask( 'apply', 'save' );
        $_SERVER['QUERY_STRING'] = "index.php?option=com_jshopping&controller=products&category_id=0";//submenu active 
    }
    
    function display(){
    global $mainframe;
    
        $db = &JFactory::getDBO();
        $jshopConfig = &JSFactory::getConfig();        
        $products = &$this->getModel("products");    

        $context = "jshoping.list.admin.product";
        $limit = $mainframe->getUserStateFromRequest( $context.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
        $limitstart = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );
        $category_id = $mainframe->getUserStateFromRequest( $context.'category_id', 'category_id', 0, 'int' );
        $text_search = $mainframe->getUserStateFromRequest( $context.'text_search', 'text_search', '');
                
        $total = $products->getCountAllProducts($category_id, $text_search);
        
        jimport('joomla.html.pagination');
        $pagination = new JPagination($total, $limitstart, $limit);
        
        $rows = $products->getAllProducts($category_id, null, $pagination->limitstart, $pagination->limit, $text_search);
        
        $parentTop->category_id = 0;
        $parentTop->name = _JSHOP_ALL_PRODUCTS;
        $categories_select = buildTreeCategory(0);
        array_unshift($categories_select, $parentTop);    
        $lists['treecategories'] = JHTML::_('select.genericlist', $categories_select,'category_id','class="inputbox" onchange="document.adminForm.submit();"','category_id','name', $category_id );
        
        $currency =& JTable::getInstance('currency', 'jshop');
        $currency->load($jshopConfig->mainCurrency);
        
        $view=&$this->getView("product_list", 'html');
        $view->assign('rows', $rows);
        $view->assign('lists', $lists);
        $view->assign('category_id', $category_id);
        $view->assign('pagination', $pagination);
        $view->assign('text_search', $text_search);
        $view->assign('config', $jshopConfig);
        $view->assign('currency', $currency);
        $view->display();
				
    }
    
    function edit() {

        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        
        $product_id = JRequest::getInt('product_id');
        $products = &$this->getModel("products");
        
        $product =& JTable::getInstance('product', 'jshop');
        $product->load($product_id);

        $_productprice =& JTable::getInstance('productPrice', 'jshop');
        $product->product_add_prices = $_productprice->getAddPrices($product_id);        
        $product->product_add_prices = array_reverse($product->product_add_prices);
        
        $_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        $multilang = count($languages)>1;
        
        $nofilter = array();
        foreach($languages as $lang){
            $nofilter[] = "description_".$lang->language;
            $nofilter[] = "short_description_".$lang->language;
        }
        JFilterOutput::objectHTMLSafe( $product, ENT_QUOTES, $nofilter);

        $edit = intval($product_id);
        
        if(!$product_id) {
            $rows = array();
            $category->products_sorting = 1;
            $category->products_sorting2 = 1;
            $product->product_quantity = 1;
            $product->product_publish = 1;
        }
 
        $all_products = $products->getAllProducts(0, $product_id);        
        $_tax = &$this->getModel("taxes");
        $all_taxes = $_tax->getAllTaxes();
        
        if($edit){
            $images = $product->getImages();
            $videos = $product->getVideos();
            $categories_select = $product->getCategories();
            $related_pr = $products->getRelatedProducts($product_id);
        } else {
            $images = array();
            $videos = array();
            $categories_select = null;
            $related_pr = array();
        }
        $list_tax = array();        
        foreach ($all_taxes as $tax) {
            $list_tax[] = JHTML::_('select.option', $tax->tax_id, $tax->tax_name . ' (' . $tax->tax_value . '%)','tax_id','tax_name');
        }

        $categories = buildTreeCategory(0);
        if (count($categories)==0) JError::raiseNotice(0, _JSHOP_PLEASE_ADD_CATEGORY);
        $lists['images'] = $images;
        $lists['videos'] = $videos;

        $manuf1[0]->manufacturer_id = '0';
        $manuf1[0]->name = _JSHOP_NONE;

        $_manufacturer =&$this->getModel('manufacturers');
        $manufs = $_manufacturer->getAllManufacturers(0);
        $manufs = array_merge($manuf1, $manufs);

        //Attributes
        $_attribut = &$this->getModel('attribut');
        $_attribut_value =&$this->getModel('attributValue');
        $lists['attribs'] = $product->getAttributes();
        $lists['attribs_values'] = $_attribut_value->getAllAttributeValues(2);
        $all_attributes = $_attribut->getAllAttributes();
        
        $first[] = JHTML::_('select.option', '0',_JSHOP_SELECT, 'value_id','name');

        foreach ($all_attributes as $key => $value) {
            $values_for_attribut = $_attribut_value->getAllValues($value->attr_id);
            if(!count($values_for_attribut)) {
                unset($all_attributes[$key]);
                continue;
            }
            $all_attributes[$key]->values_select = JHTML::_('select.genericlist', array_merge($first, $values_for_attribut),'value_id['.$value->attr_id.']','class = "inputbox" size = "1" id = "value_id_'.$value->attr_id.'" onchange="changeAttrAdmin(\''.$value->attr_id.'\',this.value)"','value_id','name');
            $all_attributes[$key]->values = $values_for_attribut;
        }        
        $lists['all_attributes'] = $all_attributes;
        // End work with attributes and values

        $lists['manufacturers'] = JHTML::_('select.genericlist', $manufs,'product_manufacturer_id','class = "inputbox" size = "1"','manufacturer_id','name',$product->product_manufacturer_id);
        
        $tax_value = 0;
        foreach ($all_taxes as $tax){
            if ($tax->tax_id == $product->product_tax_id){
                $tax_value = $tax->tax_value;
                break; 
            }
        }
        $lists['tax'] = JHTML::_('select.genericlist', $list_tax,'product_tax_id','class = "inputbox" size = "1" id = "product_tax_id" onchange = "updateNet(); updateGross()"','tax_id','tax_name',$product->product_tax_id);
        $lists['categories'] = JHTML::_('select.genericlist', $categories,'category_id[]','class="inputbox" size="10" multiple = "multiple" id  = "category_id"','category_id','name',$categories_select);
        $lists['writeable'] = (is_writable($jshopConfig->image_product_path))?($jshopConfig->image_product_path . '::' . messageOutput(_JSHOP_WRITEABLE,'jshop_green')):($jshopConfig->image_product_path . '::' . messageOutput(_JSHOP_NON_WRITEABLE));
        $lists['templates'] = getTemplates('product', $product->product_template);
        
        $related_product = array(); 
        $related_product[] = JHTML::_('select.option', '0', " - - - ", 'product_id', 'name');
        $related_products = array_merge($related_product, $all_products);    
        $lists['related'] = JHTML::_('select.genericlist', $related_products, 'related_products[]','class = "inpubox" size = "10" multiple = "multiple"', 'product_id', 'name', $related_pr);
        if (!$product->product_count_related)  $product->product_count_related = $jshopConfig->count_products_to_row;
        
        $currency =& JTable::getInstance('currency', 'jshop');
        $currency->load($jshopConfig->mainCurrency);

        $view=&$this->getView("product_edit", 'html');
 
        $view->assign('product', $product);
        $view->assign('lists', $lists);
        $view->assign('edit', $edit);
        $view->assign('currency', $currency);
        $view->assign('tax_value', $tax_value);
        $view->assign('languages', $languages);
        $view->assign('multilang', $multilang);
        $view->display();
    }
    
    function save() {
        $jshopConfig = &JSFactory::getConfig();
        
        require_once ($jshopConfig->path.'lib/thumbnail_images.class.php');
        require_once ($jshopConfig->path.'lib/uploadfile.class.php');
        
        $db = &JFactory::getDBO();
        $post = JRequest::get('post');
               
        if (!isset($post['product_publish'])) $post['product_publish'] = 0;
        if (!isset($post['product_is_add_price'])) $post['product_is_add_price'] = 0;        
        $post['product_price'] = saveAsPrice($post['product_price']);
        $post['product_old_price'] = saveAsPrice($post['product_old_price']);
        $post['product_buy_price'] = saveAsPrice($post['product_buy_price']);
        if(!isset($post['related_products'])) $post['related_products'] = array();
        if (!$post['product_id']) $post['product_date_added'] = date("Y-m-d H:i:s");
        $post['edit'] = intval($post['product_id']);
        
        if (is_array($post['attr_count'])){
            $qty = 0;
            foreach($post['attr_count'] as $_qty) {
                $qty += $_qty;
            }
            $post['product_quantity'] = $qty;
        }
        
        $_products = &$this->getModel("products");
        $product =& JTable::getInstance('product', 'jshop');
        
        $_lang = &$this->getModel("languages");
        $languages = $_lang->getAllLanguages(1);
        foreach($languages as $lang){            
            $post['description_'.$lang->language] = JRequest::getVar('description'.$lang->id,'','post',"string",4);
            $post['short_description_'.$lang->language] = JRequest::getVar('short_description_'.$lang->language,'','post',"string",4);
        }
        
        if(!$product->bind($post)) {
            JError::raiseWarning("",_JSHOP_ERROR_BIND);
            $this->setRedirect("index.php?option=com_jshopping&controller=products");
            return 0;
        }
        
        if(isset($post['set_main_image'])) {
            $image=& JTable::getInstance('image', 'jshop');
            $image->load($post['set_main_image']);
            if($image->image_id) {
                $product->product_thumb_image = $image->image_thumb;
                $product->product_name_image = $image->image_name;
                $product->product_full_image = $image->image_full;
            }
        }
        
        $upload = new UploadFile($_FILES['product_download_file']);
        $upload->setDir($jshopConfig->product_demo_path);
        $upload->setFileNameMd5(0);
        if ($upload->upload()){
            $old_file = $product->getDownloadFile();
            if ($old_file){
                @unlink($jshopConfig->product_demo_path."/".$old_file);
            }
            $product->product_download_file = $upload->getName();
        }else{
            if ($upload->getError() != 4){
                JError::raiseWarning("", _JSHOP_ERROR_UPLOADING_FILE_DEMO);    
            }
        }               
        unset($upload);
        
        if(!$product->store()){
            JError::raiseWarning("",_JSHOP_ERROR_SAVE_DATABASE."<br>".$product->_error);
            $this->setRedirect("index.php?option=com_jshopping&controller=products&task=edit&product_id=".$product->product_id);
            return 0;
        }

        $product_id = $product->product_id;
        
        $_products->saveAditionalPrice($product_id, $post['product_add_price'], $post['quantity_start'], $post['quantity_finish'], $post['product_add_price_delete'], $post['product_is_add_price']);

        //upload video
        for($i=0; $i<3; $i++){
            $upload = new UploadFile($_FILES['product_video_'.$i]);
            $upload->setDir($jshopConfig->video_product_path);
            if ($upload->upload()){
                $image_prev_video = "";
                $file_video = $upload->getName();
                
                $upload2 = new UploadFile($_FILES['product_video_preview_'.$i]);
                $upload2->setAllowFile(array('jpeg','jpg','gif','png'));
                $upload2->setDir($jshopConfig->video_product_path."/preview");
                if ($upload2->upload()){
                    $image_prev_video = $upload2->getName();    
                }else{
                    if ($upload2->getError() != 4){
                        JError::raiseWarning("", _JSHOP_ERROR_UPLOADING_VIDEO_PREVIEW);
                    }    
                }
                unset($upload2);                
                $this->addToProductVideo($product_id, $file_video, $image_prev_video);
            }else{
                if ($upload->getError() != 4){
                    JError::raiseWarning("", _JSHOP_ERROR_UPLOADING_VIDEO);    
                }
            }               
            unset($upload);    
        }
        
        //uploading images
        for($i=0; $i<10; $i++){
            $upload = new UploadFile($_FILES['product_image_'.$i]);
            $upload->setAllowFile(array('jpeg','jpg','gif','png'));
            $upload->setDir($jshopConfig->image_product_path);
            if ($upload->upload()){
                $name_image = $upload->getName();
                $name_thumb = 'thumb_'.$name_image;
                $name_full = 'full_'.$name_image;

                $path_image = $jshopConfig->image_product_path . "/" . $name_image;
                $path_thumb = $jshopConfig->image_product_path . "/" . $name_thumb;
                $path_full =  $jshopConfig->image_product_path . "/" . $name_full;                
                rename($path_image, $path_full);
                
                $error = 0;
                if($post['size_im_product'] == 3) {
                    copy($path_full, $path_thumb);
                }else{
                    if($post['size_im_product'] == 1){
                        $product_width_image = $jshopConfig->image_product_width;
                        $product_height_image = $jshopConfig->image_product_height;
                    }else{
                        $product_width_image = JRequest::getInt('product_width_image'); 
                        $product_height_image = JRequest::getInt('product_height_image');
                    }
        
                    $img = new thumbnail_images();
                    $img->PathImgOld = $path_full;
                    $img->PathImgNew = $path_thumb;
                    $img->NewWidth = $product_width_image;
                    $img->NewHeight = $product_height_image;

                    if(!$img->create_thumbnail_images()) {
                        JError::raiseWarning("",_JSHOP_ERROR_CREATE_THUMBAIL);
                        $error = 1;
                    }    
                    unset($img);
                }
                
                if($post['size_full_product'] == 3){
                    copy($path_full, $path_image);
                }else{
                    if($post['size_full_product'] == 1){
                        $product_full_width_image = $jshopConfig->image_product_full_width; 
                        $product_full_height_image = $jshopConfig->image_product_full_height;
                    }else{
                        $product_full_width_image = JRequest::getInt('product_full_width_image'); 
                        $product_full_height_image = JRequest::getInt('product_full_height_image');
                    }
                    
                    $img = new thumbnail_images();
                    $img->PathImgOld = $path_full;
                    $img->PathImgNew = $path_image;
                    $img->NewWidth = $product_full_width_image;
                    $img->NewHeight = $product_full_height_image;

                    if(!$img->create_thumbnail_images()){
                        JError::raiseWarning("",_JSHOP_ERROR_CREATE_THUMBAIL);
                        $error = 1;
                    }    
                    unset($img);
                }
                                                
                if (!$error){
                    $this->addToProductImage($product_id, $name_full, $name_image, $name_thumb);
                }
                
            }else{
                if ($upload->getError() != 4){
                    JError::raiseWarning("", _JSHOP_ERROR_UPLOADING_IMAGE);
                }
            }
                        
            unset($upload);    
        }
        
        if (!$product->product_name_image){
            $list_images = $product->getImages();
            if (count($list_images)){
                $product =& JTable::getInstance('product', 'jshop');
                $product->load($product_id);
                $product->product_thumb_image = $list_images[0]->image_thumb;
                $product->product_name_image = $list_images[0]->image_name;
                $product->product_full_image = $list_images[0]->image_full;
                $product->store();    
            }
        }

        // save attributes
        $query = "DELETE FROM `#__jshopping_products_attr` WHERE `product_id` = '" . $db->getEscaped($product_id) . "'";
        $db->setQuery($query);
        $db->query();
        
        if (is_array($post['attrib_price'])){
            foreach($post['attrib_price'] as $k=>$v){
                $a_price = saveAsPrice($post['attrib_price'][$k]);
                $a_buy_price = saveAsPrice($post['attrib_buy_price'][$k]);
                $a_count = intval($post['attr_count'][$k]);
                $a_ean = $post['attr_ean'][$k];
                $query_attr = "";
                foreach($post['attrib_id'] as $field_id=>$val){
                    $query_attr .= " `attr_".intval($field_id)."` = '".$db->getEscaped($val[$k])."', ";
                }
                $query = "INSERT INTO `#__jshopping_products_attr` SET 
                            `product_id` = '".$db->getEscaped($product_id)."', ".$query_attr."
                            `buy_price` = '".$db->getEscaped($a_buy_price)."', 
                            `price` = '".$db->getEscaped($a_price)."',
                            `count` = '".$db->getEscaped($a_count)."',
                            `ean` = '".$db->getEscaped($a_ean)."'";
                $db->setQuery($query);
                $db->query();                        
            }
        }

        $_products->setCategoryToProduct($product_id, $post['category_id']);

        if($post['edit']) {
            $query = "DELETE FROM `#__jshopping_products_relations` WHERE `product_id` = '".$db->getEscaped($product_id)."'";
            $db->setQuery($query);
            $db->query();
        }
        foreach ($post['related_products'] as $key => $value) {
            if ($value!=0){
                $query = "INSERT INTO `#__jshopping_products_relations` SET `product_id` = '" . $db->getEscaped($product_id) . "', `product_related_id` = '" . $db->getEscaped($value) . "'";
                $db->setQuery($query);
                $db->query();
            }
        }
        
        if ($this->getTask()=='apply'){
            $this->setRedirect("index.php?option=com_jshopping&controller=products&task=edit&product_id=".$product->product_id, _JSHOP_PRODUCT_SAVED);
        }else{
            $this->setRedirect("index.php?option=com_jshopping&controller=products", _JSHOP_PRODUCT_SAVED);
        }        
    }
    
    function addToProductImage($product_id, $name_full, $name_image, $name_thumb) {
        $db = &JFactory::getDBO();
        $query = "INSERT INTO `#__jshopping_products_images`
                   SET `product_id` = '" . $db->getEscaped($product_id) . "', `image_full` = '" . $db->getEscaped($name_full) . "', `image_thumb` = '" . $db->getEscaped($name_thumb) . "', `image_name` = '" . $db->getEscaped($name_image) . "'";
        $db->setQuery($query);
        $db->query();
    }

    function addToProductVideo($product_id,$name_video,$preview_image = '') {
        $db = &JFactory::getDBO();
        $query = "INSERT INTO `#__jshopping_products_videos`
                   SET `product_id` = '" . $db->getEscaped($product_id) . "', `video_name` = '" . $db->getEscaped($name_video) . "', `video_preview` = '" . $db->getEscaped($preview_image) . "'";
        $db->setQuery($query);
        $db->query();
    }   
    
    function publish(){        
        $this->_publishProduct(1);
        $this->setRedirect("index.php?option=com_jshopping&controller=products");
    }
    
    function unpublish(){
        $this->_publishProduct(0);
        $this->setRedirect("index.php?option=com_jshopping&controller=products");
    }    
    
    function _publishProduct($flag) {
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        $cid = JRequest::getVar('cid');
        $query = '';
        foreach ($cid as $key => $value) {
            $query = "UPDATE `#__jshopping_products`
                       SET `product_publish` = '" . $db->getEscaped($flag) . "'
                       WHERE `product_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();
        }
    }

    function copy(){
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        $text = array();
        $cid = JRequest::getVar('cid');
        // Get all data about products
        $tables = array('attr', 'images', 'prices', 'relations', 'to_categories', 'videos');
        foreach ($cid as $key=>$value){
            $product =& JTable::getInstance('product', 'jshop');
            $product->load($value);
            $product->product_id = null;
            $product->store();

            $array = array();
            foreach ($tables as $table){
                $query = "SELECT * FROM `#__jshopping_products_" . $table . "` AS prod_table WHERE prod_table.product_id = '" . $db->getEscaped($value) . "'";
                $db->setQuery($query);
                $array[] = $db->loadAssocList();
            }

            $i = 0;
            foreach ($array as $key2=>$value2){
                if (count($value2)){
                    foreach ($value2 as $key3=>$value3){
                        $db->setQuery($this->_buildQuery($tables[$i], $value3, $product->product_id));
                        $db->query();
                    }
                }
                $i++;                
            }
            
            //change order in category
            $query = "select * from #__jshopping_products_to_categories where product_id='".$product->product_id."'";
            $db->setQuery($query);
            $list = $db->loadObjectList();
        
            foreach($list as $val){
                $query = "select max(product_ordering) as k from #__jshopping_products_to_categories where category_id='".$val->category_id."' ";
                $db->setQuery($query);
                $ordering = $db->loadResult() + 1;
                
                $query = "update #__jshopping_products_to_categories set product_ordering='".$ordering."' where category_id='".$val->category_id."' and product_id='".$product->product_id."' ";
                $db->setQuery($query);
                $db->query();
            }            
            
            $text[]= sprintf(_JSHOP_PRODUCT_COPY_TO, $value, $product->product_id)."<br>";
        }
        $this->setRedirect("index.php?option=com_jshopping&controller=products", implode("</li><li>",$text));
    }
    
    function _buildQuery($table, $array, $product_id){
    	$db = &JFactory::getDBO();
        $query = "INSERT INTO `#__jshopping_products_" . $table . "` SET ";
        $array_keys = array('image_id', 'price_id', 'review_id', 'video_id', 'product_attr_id', 'value_id');
        foreach ($array as $key=>$value){
            if (in_array($key, $array_keys)) continue;
            if ($key=='product_id') $value = $product_id;
            $query .= "`" . $key . "` = '" . $db->getEscaped($value) . "', ";
        }
        return $query = substr($query, 0, strlen($query) - 2);
    }
    
    function order() {
        $order = JRequest::getVar("order");
        $product_id = JRequest::getInt("product_id");
        $number = JRequest::getInt("number");
        $category_id = JRequest::getInt("category_id");

        $db = &JFactory::getDBO();
        switch ($order) {
            case 'up':
                $query = "SELECT a.*
                       FROM `#__jshopping_products_to_categories` AS a
                       WHERE a.product_ordering < '" . $number . "' AND a.category_id = '" . $category_id . "'
                       ORDER BY a.product_ordering DESC
                       LIMIT 1";
                break;
            case 'down':
                $query = "SELECT a.*
                       FROM `#__jshopping_products_to_categories` AS a
                       WHERE a.product_ordering > '" . $number . "' AND a.category_id = '" . $category_id . "'
                       ORDER BY a.product_ordering ASC
                       LIMIT 1";
        }

        $db->setQuery($query);
        $row = $db->loadObject();

        $query1 = "UPDATE `#__jshopping_products_to_categories` AS a
                     SET a.product_ordering = '" . $row->product_ordering . "'
                     WHERE a.product_id = '" . $product_id . "' AND a.category_id = '" . $category_id . "'";
        $query2 = "UPDATE `#__jshopping_products_to_categories` AS a
                     SET a.product_ordering = '" . $number . "'
                     WHERE a.product_id = '" . $row->product_id . "' AND a.category_id = '" . $category_id . "'";
        $db->setQuery($query1);
        $db->query();
        $db->setQuery($query2);
        $db->query();
        $this->setRedirect("index.php?option=com_jshopping&controller=products&category_id=".$category_id); 
    }
    
    function remove(){
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        $text = array();
        $cid = JRequest::getVar('cid'); 

        foreach ($cid as $key => $value) {
            $product =& JTable::getInstance('product', 'jshop');
            $product->load($value);
            $query = "DELETE FROM `#__jshopping_products`
                       WHERE `product_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();

            $query = "DELETE FROM `#__jshopping_products_attr` WHERE `product_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();
            
            $query = "DELETE FROM `#__jshopping_products_prices` WHERE `product_id` = '".$db->getEscaped($value)."'";
            $db->setQuery($query);
            $db->query();
            
            $query = "DELETE FROM `#__jshopping_products_relations` WHERE `product_id` = '" . $db->getEscaped($value) . "' OR `product_related_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();

            $query = "DELETE FROM `#__jshopping_products_to_categories` WHERE `product_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();

            $images = $product->getImages();
            $videos = $product->getVideos();

            if($product->product_download_file) {
                $query = "select count(*) as k from #__jshopping_products where product_download_file='".$db->getEscaped($product->product_download_file)."' and product_id!='".$db->getEscaped($value)."'";
                $db->setQuery($query);
                if (!$db->loadResult()){
                    @unlink($jshopConfig->product_demo_path."/".$product->product_download_file);
                }
            }

            if(count($images)) {
                foreach ($images as $image){
                    $query = "select count(*) as k from #__jshopping_products_images where image_name='".$db->getEscaped($image->image_name)."' and product_id!='".$db->getEscaped($value)."'";                    
                    $db->setQuery($query);
                    if (!$db->loadResult()){
                        @unlink($jshopConfig->image_product_path . "/" . $image->image_thumb);
                        @unlink($jshopConfig->image_product_path . "/" . $image->image_full);
                        @unlink($jshopConfig->image_product_path . "/" . $image->image_name);
                    }
                }
            }
            
            $query = "DELETE FROM `#__jshopping_products_images` WHERE `product_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();

            if(count($videos)) {
                foreach ($videos as $video) {
                    $query = "select count(*) as k from #__jshopping_products_videos where video_name='".$db->getEscaped($video->video_name)."' and product_id!='".$db->getEscaped($value)."'";                    
                    $db->setQuery($query);
                    if (!$db->loadResult()){
                        @unlink($jshopConfig->video_product_path . "/" . $video->video_name);
                        if ($video->video_preview){
                            @unlink($jshopConfig->video_product_path . "/preview/" . $video->video_preview);
                        }
                    }
                }
            }
            
            $query = "DELETE FROM `#__jshopping_products_videos` WHERE `product_id` = '" . $db->getEscaped($value) . "'";
            $db->setQuery($query);
            $db->query();
            
            $text[]= sprintf(_JSHOP_PRODUCT_DELETED, $value)."<br>";
        }

        $this->setRedirect("index.php?option=com_jshopping&controller=products", implode("</li><li>",$text));
    }
    
    function delete_foto(){
        $image_id = JRequest::getInt("id");
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        
        $query = "SELECT * FROM `#__jshopping_products_images` WHERE image_id = '" . $db->getEscaped($image_id) . "'";
        $db->setQuery($query);
        $row = $db->loadObject($row);
        
        $query = "DELETE FROM `#__jshopping_products_images` WHERE `image_id` = '" . $db->getEscaped($image_id) . "'";
        $db->setQuery($query);
        $db->query();
        
        $query = "select count(*) as k from #__jshopping_products_images where image_name='".$db->getEscaped($row->image_name)."' and product_id!='".$db->getEscaped($row->product_id)."'";                    
        $db->setQuery($query);
        if (!$db->loadResult()){        
            @unlink($jshopConfig->image_product_path . '/' . $row->image_full);
            @unlink($jshopConfig->image_product_path . '/' . $row->image_name);
            @unlink($jshopConfig->image_product_path . '/' . $row->image_thumb);
        }
        
        $product =& JTable::getInstance('product', 'jshop');
        $product->load($row->product_id);
        if ($product->product_name_image==$row->image_name){
            $product->product_thumb_image = '';
            $product->product_name_image = '';
            $product->product_full_image = '';
            $list_images = $product->getImages();
            if (count($list_images)){
                $product->product_thumb_image = $list_images[0]->image_thumb;
                $product->product_name_image = $list_images[0]->image_name;
                $product->product_full_image = $list_images[0]->image_full;    
            } 
            $product->store();
        }
        
        die();
    }
    
    function delete_video(){
        $video_id = JRequest::getInt("id");
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        
        $query = "SELECT * FROM `#__jshopping_products_videos` WHERE video_id = '" . $db->getEscaped($video_id) . "'";
        $db->setQuery($query);
        $row = $db->loadObject();
        
        $query = "select count(*) from #__jshopping_products_videos where video_name='".$db->getEscaped($row->video_name)."' and product_id!='".$db->getEscaped($row->product_id)."'";                    
        $db->setQuery($query);
        if (!$db->loadResult()){
            @unlink($jshopConfig->video_product_path . "/" . $row->video_name);
            if ($row->video_preview){
                @unlink($jshopConfig->video_product_path . "/preview/" . $row->video_preview);
            }
        }

        $query = "DELETE FROM `#__jshopping_products_videos` WHERE `video_id` = '" . $db->getEscaped($video_id) . "'";
        $db->setQuery($query);
        $db->query();
        die();
    }
    
    function delete_demo_file(){
        $jshopConfig = &JSFactory::getConfig();
        $db = &JFactory::getDBO();
        $id = JRequest::getInt("id");
        $product =& JTable::getInstance('product', 'jshop');
        $product->load($id);
        if($product->product_download_file) {
            $query = "select count(*) as k from #__jshopping_products where product_download_file='".$db->getEscaped($product->product_download_file)."' and product_id!='".$db->getEscaped($id)."'";
            $db->setQuery($query);
            if (!$db->loadResult()){
                @unlink($jshopConfig->product_demo_path."/".$product->product_download_file);
            }
            
            $product->product_download_file = "";
            $product->store();
        }
        die();
            
    }
        
        
}
?>