<?php
define('K_TCPDF_EXTERNAL_CONFIG', true);

// Installation path
define("K_PATH_MAIN", JPATH_LIBRARIES.DS."tcpdf");

// URL path
define("K_PATH_URL", JPATH_SITE);

// Fonts path
define("K_PATH_FONTS", JPATH_SITE.DS.'language'.DS."pdf_fonts".DS);

// Cache directory path
define("K_PATH_CACHE", K_PATH_MAIN.DS."cache");

// Cache URL path
define("K_PATH_URL_CACHE", K_PATH_URL.DS."cache");

// Images path
define("K_PATH_IMAGES", K_PATH_MAIN.DS."images");

// Blank image path
define("K_BLANK_IMAGE", K_PATH_IMAGES.DS."_blank.png");

/*
 * Format options
 */

// Cell height ratio
define("K_CELL_HEIGHT_RATIO", 1.5);

// Magnification scale for titles
define("K_TITLE_MAGNIFICATION", 1);

// Reduction scale for small font
define("K_SMALL_RATIO", 2/3);

// Magnication scale for head
define("HEAD_MAGNIFICATION", 1);

include(JPATH_SITE."/libraries/tcpdf/tcpdf.php");

error_reporting(1);

function getCountRowText($str){    
return (substr_count($str, "\n") + 1);
}

class MYPDF extends TCPDF{
	function addNewPage(){
		$this->addPage();
		$this->addTitleHead();	
	}
	function addTitleHead(){
		$jshopConfig = &JSFactory::getConfig();        
		$this->Image($jshopConfig->path . '/images/header.jpg',1,1,$jshopConfig->pdf_header_width,$jshopConfig->pdf_header_height);
		$this->Image($jshopConfig->path . '/images/footer.jpg',1,265,$jshopConfig->pdf_footer_width,$jshopConfig->pdf_footer_height);
        $this->SetFont('freesans','',8);
        $this->SetXY(155,12);
        $this->SetTextColor(155,155,155);
        $this->MultiCell(40,3,$jshopConfig->store_address . "\n" . $jshopConfig->store_zip . " " . $jshopConfig->store_city . "\n" . _JSHOP_CONTACT_PHONE . ":" . $jshopConfig->contact_phone . "\n" . _JSHOP_CONTACT_FAX . ":" . $jshopConfig->contact_fax,0,'R');
        $this->SetTextColor(0,0,0);
	}	
}

function generatePDF($order){
        
    $jshopConfig = &JSFactory::getConfig();
    
	$pdf = new MYPDF();
    $pdf->SetFont('freesans','',8);
    $pdf->setPrintHeader(false);
    $pdf->setPrintFooter(false);
    $pdf->SetMargins(0, 0, 0);
	$pdf->addNewPage();	
    
	$pdf->SetXY(20,55);
	$pdf->setfontsize(6);
	$pdf->SetTextColor(0,0,0);
	$pdf->MultiCell(80,3,$jshopConfig->store_company_name . ", " . $jshopConfig->store_address . ", " . $jshopConfig->store_zip . " " . $jshopConfig->store_city,0,'L');
	
	$pdf->SetXY(110,55);
	$pdf->SetFont('freesansb','',11);
	$pdf->SetTextColor(0,0,0);
	$pdf->MultiCell(80,3,_JSHOP_EMAIL_BILL,0,'R');
	
	$pdf->SetFont('freesans','',11);
	$pdf->SetXY(20,60);
	$pdf->MultiCell(80,4.5,$order->firma_name . "\n" . $order->f_name . " " . $order->l_name . "\n" . $order->street . "\n" . $order->zip . " " . $order->city . "\n" . $order->country, 0,'L');
	
	$pdf->SetFont('freesansi','',11);
	$pdf->SetXY(110,65);
	$pdf->MultiCell(80,4.5,_JSHOP_ORDER_SHORT_NR . " " . $order->order_number . "\n" . _JSHOP_ORDER_FROM . " " . $order->order_date,0,'R');
	$pdf->SetDrawColor(0,0,0);
	$pdf->SetFont('freesans','',7);
	$pdf->SetXY(150,96);
	$pdf->setfillcolor(200,200,200);
	$pdf->Rect(20,115,170,5,'F');
	$pdf->SetFont('freesansb','',9);
	$pdf->SetXY(20,115);
	$pdf->MultiCell(130, 5, _JSHOP_DESCRIPTION, 1, 'L');
	$pdf->SetXY(150,115);
	$pdf->MultiCell(40,5,_JSHOP_TOTAL, 1,'R');
	
    $y = 120;	
	foreach ($order->products as $prod){
		$descr = $prod['product_name'];        
		if (isset($prod['attributes_value'])){
			$descr_attr = "";
			foreach ($prod['attributes_value'] as $attr){
				$descr_attr .= "\n  ".$attr->attr.": ".$attr->value; 
			} 
            $descr .= $descr_attr;
		}        

		$text_count_row = getCountRowText($descr);        
        $height = $text_count_row * 4;
        $pdf->SetFont('freesans','',7);
        $pdf->SetXY(20, $y + 2);
        $pdf->MultiCell(130, $height, $descr, 0 , 'L');
        $y2 = $pdf->getY() + 2;
        $pdf->Rect(20, $y, 170, $y2 - $y );
        
        $pdf->SetXY(150, $y + 2);
        $pdf->MultiCell(40, $height, formatprice($prod['quantity'] * $prod['price']), 0 , 'R');
        $pdf->Rect(20, $y, 130, $y2 - $y );
        
        $y = $y2; 
		
        
        if ($y > 260){
            $pdf->addNewPage();
            $y = 60;
        }
	}
    
	if ($y > 240){
        $pdf->addNewPage();
        $y = 60;
    }
	
	$pdf->SetFont('freesansb','',10);
		
	$pdf->SetXY(20,$y);
	$pdf->Rect(20,$y,170,5,'F');
	$pdf->MultiCell(130,5,_JSHOP_SUBTOTAL,'1','R');	
	$pdf->SetXY(150,$y);	
	$pdf->MultiCell(40,5,formatprice($order->order_subtotal),'1','R');
    
    if ($order->order_discount){
        $y = $y + 5;     
        $pdf->SetXY(20,$y);
        $pdf->Rect(20,$y,170,5,'F');
        $pdf->MultiCell(130,5,_JSHOP_RABATT_VALUE,'1','R');
        $pdf->SetXY(150,$y);
        $pdf->MultiCell(40,5, "-".formatprice($order->order_discount),'1','R');       
    }
	
    if (!$jshopConfig->without_shipping){
	    $pdf->SetXY(20,$y + 5);
	    $pdf->Rect(20,$y + 5,170,5,'F');
	    $pdf->MultiCell(130,5,_JSHOP_SHIPPING_PRICE,'1','R');
	    $pdf->SetXY(150,$y + 5);
	    $pdf->MultiCell(40,5,formatprice($order->order_shipping),'1','R');
    }else{
        $y = $y - 5;
    }
		
	$pdf->SetXY(20,$y + 10);
	$pdf->Rect(20,$y + 10,170,5,'F');
	$pdf->MultiCell(130,5,_JSHOP_INC_TAX ,'1','R');
	
	$pdf->SetXY(150,$y + 10);
	$pdf->MultiCell(40,5,formatprice($order->order_tax),'1','R');
	
	
	$pdf->SetXY(20,$y + 15);
	$pdf->Rect(20,$y + 15,170, 5.1,'F');
	$pdf->MultiCell(130, 5 ,_JSHOP_TOTAL,'1','R');
	
	$pdf->SetXY(150,$y + 15);
	$pdf->MultiCell(40,5,formatprice($order->order_total),'1','R');
	
	$y = $y + 35;
    
    if ($y > 240){
        $pdf->addNewPage();
        $y = 60;
    }
    
	$pdf->SetFont('freesans','',7);
	$pdf->SetXY(115, $y);
	$pdf->Rect(115, $y, 75,4,'F');
	$pdf->MultiCell(75,4,_JSHOP_BENEF_BANK,'1','L');
	$pdf->SetXY(115, 4 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->benef_bank_info,'1','L');
	$pdf->SetXY(115,8 + $y);
	$pdf->MultiCell(75,4,_JSHOP_BENEF_BIC,'1','L');
	$pdf->SetXY(115,12 + $y);
	$pdf->MultiCell(75,4,_JSHOP_BENEF_CONTO,'1','L');
	
	$pdf->SetXY(115,16 + $y);
	$pdf->MultiCell(75,4,_JSHOP_BENEF_IBAN,'1','L');
	
	$pdf->SetXY(115,20 + $y);
	$pdf->MultiCell(75,4,_JSHOP_BENEF_SWIFT,'1','L');
	
	$pdf->Rect(115,24 + $y,75,4,'F');
	$pdf->SetXY(115,24 + $y);
	$pdf->MultiCell(75,4,_JSHOP_INTERM_BANK,'1','L');
	
	$pdf->SetXY(115,28 + $y);
	$pdf->MultiCell(75,4,_JSHOP_INTERM_NAME,'1','L');
	
	$pdf->SetXY(115,32 + $y);
	$pdf->MultiCell(75,4,_JSHOP_INTERM_SWIFT,'1','L');

	$pdf->SetXY(115,8 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->benef_bic,'0','R');
	
	$pdf->SetXY(115,12 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->benef_conto,'0','R');
	
	$pdf->SetXY(115,16 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->benef_iban,'0','R');
	
	$pdf->SetXY(115,20 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->benef_swift,'0','R');
	
	
	$pdf->SetXY(115,28 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->interm_name,'0','R');
	
	$pdf->SetXY(115,32 + $y);
	$pdf->MultiCell(75,4,$jshopConfig->interm_swift,'0','R');
    
	$name_pdf = $order->order_id."_".md5(uniqid(rand(0,100))) . ".pdf";
	$pdf->Output($jshopConfig->pdf_orders_path."/".$name_pdf ,'F');    
	return $name_pdf;
}
?>